# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ZIAActivationStatusArgs', 'ZIAActivationStatus']

@pulumi.input_type
class ZIAActivationStatusArgs:
    def __init__(__self__, *,
                 status: pulumi.Input[str]):
        """
        The set of arguments for constructing a ZIAActivationStatus resource.
        :param pulumi.Input[str] status: Activates configuration changes.
        """
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def status(self) -> pulumi.Input[str]:
        """
        Activates configuration changes.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: pulumi.Input[str]):
        pulumi.set(self, "status", value)


@pulumi.input_type
class _ZIAActivationStatusState:
    def __init__(__self__, *,
                 status: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ZIAActivationStatus resources.
        :param pulumi.Input[str] status: Activates configuration changes.
        """
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Activates configuration changes.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)


class ZIAActivationStatus(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_zia as zia
        import zscaler_pulumi_zia as zia

        activation_zia_activation_status = zia.get_zia_activation_status()
        activation_index_z_ia_activation_status_zia_activation_status = zia.ZIAActivationStatus("activationIndex/zIAActivationStatusZIAActivationStatus", status="ACTIVE")
        ```

        ## Import

        Activation is not an importable resource.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] status: Activates configuration changes.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ZIAActivationStatusArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_zia as zia
        import zscaler_pulumi_zia as zia

        activation_zia_activation_status = zia.get_zia_activation_status()
        activation_index_z_ia_activation_status_zia_activation_status = zia.ZIAActivationStatus("activationIndex/zIAActivationStatusZIAActivationStatus", status="ACTIVE")
        ```

        ## Import

        Activation is not an importable resource.

        :param str resource_name: The name of the resource.
        :param ZIAActivationStatusArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ZIAActivationStatusArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ZIAActivationStatusArgs.__new__(ZIAActivationStatusArgs)

            if status is None and not opts.urn:
                raise TypeError("Missing required property 'status'")
            __props__.__dict__["status"] = status
        super(ZIAActivationStatus, __self__).__init__(
            'zia:index/zIAActivationStatus:ZIAActivationStatus',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            status: Optional[pulumi.Input[str]] = None) -> 'ZIAActivationStatus':
        """
        Get an existing ZIAActivationStatus resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] status: Activates configuration changes.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ZIAActivationStatusState.__new__(_ZIAActivationStatusState)

        __props__.__dict__["status"] = status
        return ZIAActivationStatus(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Activates configuration changes.
        """
        return pulumi.get(self, "status")

