# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ZIAAuthSettingsURLsArgs', 'ZIAAuthSettingsURLs']

@pulumi.input_type
class ZIAAuthSettingsURLsArgs:
    def __init__(__self__, *,
                 urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a ZIAAuthSettingsURLs resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] urls: The email address of the admin user to be exported.
        """
        if urls is not None:
            pulumi.set(__self__, "urls", urls)

    @property
    @pulumi.getter
    def urls(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The email address of the admin user to be exported.
        """
        return pulumi.get(self, "urls")

    @urls.setter
    def urls(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "urls", value)


@pulumi.input_type
class _ZIAAuthSettingsURLsState:
    def __init__(__self__, *,
                 urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering ZIAAuthSettingsURLs resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] urls: The email address of the admin user to be exported.
        """
        if urls is not None:
            pulumi.set(__self__, "urls", urls)

    @property
    @pulumi.getter
    def urls(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The email address of the admin user to be exported.
        """
        return pulumi.get(self, "urls")

    @urls.setter
    def urls(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "urls", value)


class ZIAAuthSettingsURLs(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        The **zia_auth_settings_urls** resource alows you to add or remove a URL from the cookie authentication exempt list in the Zscaler Internet Access cloud or via the API. To learn more see [URL Format Guidelines](https://help.zscaler.com/zia/url-format-guidelines)

        ## Example Usage

        ```python
        import pulumi
        import zscaler_pulumi_zia as zia

        # ZIA User Auth Settings Data Source
        example = zia.ZIAAuthSettingsURLs("example", urls=[
            ".okta.com",
            ".oktacdn.com",
            ".mtls.oktapreview.com",
            ".mtls.okta.com",
            "d3l44rcogcb7iv.cloudfront.net",
            "pac.zdxcloud.net",
            ".windowsazure.com",
            ".fedoraproject.org",
            "login.windows.net",
            "d32a6ru7mhaq0c.cloudfront.net",
            ".kerberos.oktapreview.com",
            ".oktapreview.com",
            "login.zdxcloud.net",
            "login.microsoftonline.com",
            "smres.zdxcloud.net",
            ".kerberos.okta.com",
        ])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] urls: The email address of the admin user to be exported.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ZIAAuthSettingsURLsArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The **zia_auth_settings_urls** resource alows you to add or remove a URL from the cookie authentication exempt list in the Zscaler Internet Access cloud or via the API. To learn more see [URL Format Guidelines](https://help.zscaler.com/zia/url-format-guidelines)

        ## Example Usage

        ```python
        import pulumi
        import zscaler_pulumi_zia as zia

        # ZIA User Auth Settings Data Source
        example = zia.ZIAAuthSettingsURLs("example", urls=[
            ".okta.com",
            ".oktacdn.com",
            ".mtls.oktapreview.com",
            ".mtls.okta.com",
            "d3l44rcogcb7iv.cloudfront.net",
            "pac.zdxcloud.net",
            ".windowsazure.com",
            ".fedoraproject.org",
            "login.windows.net",
            "d32a6ru7mhaq0c.cloudfront.net",
            ".kerberos.oktapreview.com",
            ".oktapreview.com",
            "login.zdxcloud.net",
            "login.microsoftonline.com",
            "smres.zdxcloud.net",
            ".kerberos.okta.com",
        ])
        ```

        :param str resource_name: The name of the resource.
        :param ZIAAuthSettingsURLsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ZIAAuthSettingsURLsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ZIAAuthSettingsURLsArgs.__new__(ZIAAuthSettingsURLsArgs)

            __props__.__dict__["urls"] = urls
        super(ZIAAuthSettingsURLs, __self__).__init__(
            'zia:index/zIAAuthSettingsURLs:ZIAAuthSettingsURLs',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'ZIAAuthSettingsURLs':
        """
        Get an existing ZIAAuthSettingsURLs resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] urls: The email address of the admin user to be exported.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ZIAAuthSettingsURLsState.__new__(_ZIAAuthSettingsURLsState)

        __props__.__dict__["urls"] = urls
        return ZIAAuthSettingsURLs(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def urls(self) -> pulumi.Output[Sequence[str]]:
        """
        The email address of the admin user to be exported.
        """
        return pulumi.get(self, "urls")

