# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ZIAFirewallFilteringSourceGroupsArgs', 'ZIAFirewallFilteringSourceGroups']

@pulumi.input_type
class ZIAFirewallFilteringSourceGroupsArgs:
    def __init__(__self__, *,
                 ip_addresses: pulumi.Input[Sequence[pulumi.Input[str]]],
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ZIAFirewallFilteringSourceGroups resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ip_addresses: Source IP addresses to be added to the group. Enter any number of IP addresses. You can enter:
               * An IP address (198.51.100.100)
               * A range of IP addresses 192.0.2.1-192.0.2.10
               * An IP address with a netmask 203.0.113.0/24
        :param pulumi.Input[str] description: Description of the source IP group
        :param pulumi.Input[str] name: Source IP group name
        """
        pulumi.set(__self__, "ip_addresses", ip_addresses)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="ipAddresses")
    def ip_addresses(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Source IP addresses to be added to the group. Enter any number of IP addresses. You can enter:
        * An IP address (198.51.100.100)
        * A range of IP addresses 192.0.2.1-192.0.2.10
        * An IP address with a netmask 203.0.113.0/24
        """
        return pulumi.get(self, "ip_addresses")

    @ip_addresses.setter
    def ip_addresses(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "ip_addresses", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the source IP group
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Source IP group name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _ZIAFirewallFilteringSourceGroupsState:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ip_source_group_id: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ZIAFirewallFilteringSourceGroups resources.
        :param pulumi.Input[str] description: Description of the source IP group
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ip_addresses: Source IP addresses to be added to the group. Enter any number of IP addresses. You can enter:
               * An IP address (198.51.100.100)
               * A range of IP addresses 192.0.2.1-192.0.2.10
               * An IP address with a netmask 203.0.113.0/24
        :param pulumi.Input[str] name: Source IP group name
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if ip_addresses is not None:
            pulumi.set(__self__, "ip_addresses", ip_addresses)
        if ip_source_group_id is not None:
            pulumi.set(__self__, "ip_source_group_id", ip_source_group_id)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the source IP group
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="ipAddresses")
    def ip_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Source IP addresses to be added to the group. Enter any number of IP addresses. You can enter:
        * An IP address (198.51.100.100)
        * A range of IP addresses 192.0.2.1-192.0.2.10
        * An IP address with a netmask 203.0.113.0/24
        """
        return pulumi.get(self, "ip_addresses")

    @ip_addresses.setter
    def ip_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ip_addresses", value)

    @property
    @pulumi.getter(name="ipSourceGroupId")
    def ip_source_group_id(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "ip_source_group_id")

    @ip_source_group_id.setter
    def ip_source_group_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ip_source_group_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Source IP group name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


class ZIAFirewallFilteringSourceGroups(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The **zia_firewall_filtering_ip_source_groups** resource allows the creation and management of ZIA Cloud Firewall IP source groups in the Zscaler Internet Access. This resource can then be associated with a ZIA cloud firewall filtering rule.

        ## Example Usage

        ```python
        import pulumi
        import zscaler_pulumi_zia as zia

        # Add an IP address or addresses to a new IP Source Group
        example = zia.ZIAFirewallFilteringSourceGroups("example",
            description="Example",
            ip_addresses=[
                "192.168.100.1",
                "192.168.100.2",
                "192.168.100.3",
            ])
        ```

        ```python
        import pulumi
        import zscaler_pulumi_zia as zia

        # Add an IP address range(s) to a new IP Source Group
        example = zia.ZIAFirewallFilteringSourceGroups("example",
            description="Example",
            ip_addresses=["192.0.2.1-192.0.2.10"])
        ```

        ```python
        import pulumi
        import zscaler_pulumi_zia as zia

        # Add subnet to a new IP Source Group
        example = zia.ZIAFirewallFilteringSourceGroups("example",
            description="Example",
            ip_addresses=["203.0.113.0/24"])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description of the source IP group
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ip_addresses: Source IP addresses to be added to the group. Enter any number of IP addresses. You can enter:
               * An IP address (198.51.100.100)
               * A range of IP addresses 192.0.2.1-192.0.2.10
               * An IP address with a netmask 203.0.113.0/24
        :param pulumi.Input[str] name: Source IP group name
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ZIAFirewallFilteringSourceGroupsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The **zia_firewall_filtering_ip_source_groups** resource allows the creation and management of ZIA Cloud Firewall IP source groups in the Zscaler Internet Access. This resource can then be associated with a ZIA cloud firewall filtering rule.

        ## Example Usage

        ```python
        import pulumi
        import zscaler_pulumi_zia as zia

        # Add an IP address or addresses to a new IP Source Group
        example = zia.ZIAFirewallFilteringSourceGroups("example",
            description="Example",
            ip_addresses=[
                "192.168.100.1",
                "192.168.100.2",
                "192.168.100.3",
            ])
        ```

        ```python
        import pulumi
        import zscaler_pulumi_zia as zia

        # Add an IP address range(s) to a new IP Source Group
        example = zia.ZIAFirewallFilteringSourceGroups("example",
            description="Example",
            ip_addresses=["192.0.2.1-192.0.2.10"])
        ```

        ```python
        import pulumi
        import zscaler_pulumi_zia as zia

        # Add subnet to a new IP Source Group
        example = zia.ZIAFirewallFilteringSourceGroups("example",
            description="Example",
            ip_addresses=["203.0.113.0/24"])
        ```

        :param str resource_name: The name of the resource.
        :param ZIAFirewallFilteringSourceGroupsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ZIAFirewallFilteringSourceGroupsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ZIAFirewallFilteringSourceGroupsArgs.__new__(ZIAFirewallFilteringSourceGroupsArgs)

            __props__.__dict__["description"] = description
            if ip_addresses is None and not opts.urn:
                raise TypeError("Missing required property 'ip_addresses'")
            __props__.__dict__["ip_addresses"] = ip_addresses
            __props__.__dict__["name"] = name
            __props__.__dict__["ip_source_group_id"] = None
        super(ZIAFirewallFilteringSourceGroups, __self__).__init__(
            'zia:index/zIAFirewallFilteringSourceGroups:ZIAFirewallFilteringSourceGroups',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[str]] = None,
            ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            ip_source_group_id: Optional[pulumi.Input[int]] = None,
            name: Optional[pulumi.Input[str]] = None) -> 'ZIAFirewallFilteringSourceGroups':
        """
        Get an existing ZIAFirewallFilteringSourceGroups resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description of the source IP group
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ip_addresses: Source IP addresses to be added to the group. Enter any number of IP addresses. You can enter:
               * An IP address (198.51.100.100)
               * A range of IP addresses 192.0.2.1-192.0.2.10
               * An IP address with a netmask 203.0.113.0/24
        :param pulumi.Input[str] name: Source IP group name
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ZIAFirewallFilteringSourceGroupsState.__new__(_ZIAFirewallFilteringSourceGroupsState)

        __props__.__dict__["description"] = description
        __props__.__dict__["ip_addresses"] = ip_addresses
        __props__.__dict__["ip_source_group_id"] = ip_source_group_id
        __props__.__dict__["name"] = name
        return ZIAFirewallFilteringSourceGroups(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of the source IP group
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="ipAddresses")
    def ip_addresses(self) -> pulumi.Output[Sequence[str]]:
        """
        Source IP addresses to be added to the group. Enter any number of IP addresses. You can enter:
        * An IP address (198.51.100.100)
        * A range of IP addresses 192.0.2.1-192.0.2.10
        * An IP address with a netmask 203.0.113.0/24
        """
        return pulumi.get(self, "ip_addresses")

    @property
    @pulumi.getter(name="ipSourceGroupId")
    def ip_source_group_id(self) -> pulumi.Output[int]:
        return pulumi.get(self, "ip_source_group_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Source IP group name
        """
        return pulumi.get(self, "name")

